import { ReactNode } from 'react';
import Controller from '../Controller';
import { Constructor, InferStateType, ShouldUpdate, StateCompare } from '../types';
interface BuilderControllerProps<C extends Controller<InferStateType<C>>> {
    source: C;
    buildWhen?: ShouldUpdate<InferStateType<C>>;
    stateCompare?: StateCompare<InferStateType<C>>;
    children?: (state: InferStateType<C>) => ReactNode;
}
interface BuilderCtorProps<C extends Controller<InferStateType<C>>> {
    source: Constructor<C>;
    buildWhen?: ShouldUpdate<InferStateType<C>>;
    stateCompare?: StateCompare<InferStateType<C>>;
    children?: (state: InferStateType<C>, controller: C) => ReactNode;
}
interface BuilderProps<C extends Controller<InferStateType<C>>> {
    source: Constructor<C> | C;
    buildWhen?: ShouldUpdate<InferStateType<C>>;
    stateCompare?: StateCompare<InferStateType<C>>;
    children?: (state: InferStateType<C>, controller?: C) => ReactNode;
}
declare function Builder<C extends Controller<InferStateType<C>>>(props: BuilderCtorProps<C>): ReactNode | undefined;
declare function Builder<C extends Controller<InferStateType<C>>>(props: BuilderControllerProps<C>): ReactNode | undefined;
export { Builder };
export type { BuilderProps, BuilderControllerProps, BuilderCtorProps };
