import { Observable } from 'rxjs';
declare abstract class Controller<T> {
    constructor(initialState: T);
    private _state;
    private _subject;
    get observable(): Observable<T>;
    get state(): T;
    protected compareState(previous: T, current: T): boolean;
    protected emit(state: Partial<T>): void;
    dispose(): Promise<void>;
}
export default Controller;
