import { ReactNode } from 'react';
import Controller from '../Controller';
import { Constructor, InferStateType, ShouldUpdate, StateCompare } from '../types';
interface ListenerControllerProps<C extends Controller<InferStateType<C>>> {
    source: C;
    listener: (state: InferStateType<C>) => void;
    listenWhen?: ShouldUpdate<InferStateType<C>>;
    stateCompare?: StateCompare<InferStateType<C>>;
    children?: ReactNode;
}
interface ListenerCtorProps<C extends Controller<InferStateType<C>>> {
    source: Constructor<C>;
    listener: (state: InferStateType<C>, controller: C) => void;
    listenWhen?: ShouldUpdate<InferStateType<C>>;
    stateCompare?: StateCompare<InferStateType<C>>;
    children?: ReactNode;
}
interface ListenerProps<C extends Controller<InferStateType<C>>> {
    source: Constructor<C> | C;
    listener: (state: InferStateType<C>, controller?: C) => void;
    listenWhen?: ShouldUpdate<InferStateType<C>>;
    stateCompare?: StateCompare<InferStateType<C>>;
    children?: ReactNode;
}
declare function Listener<C extends Controller<InferStateType<C>>>(props: ListenerCtorProps<C>): ReactNode | undefined;
declare function Listener<C extends Controller<InferStateType<C>>>(props: ListenerControllerProps<C>): ReactNode | undefined;
export { Listener };
export type { ListenerProps, ListenerControllerProps, ListenerCtorProps };
